	  DOSSEG
	  .MODEL  small

_CODE  SEGMENT WORD PUBLIC 'CODE'	 ;Code segement
_CODE  ENDS
_DATA  SEGMENT WORD PUBLIC 'DATA'	 ;Data segement
_DATA  ENDS
STACK SEGMENT WORD PUBLIC 'STACK'	 ;Stack segement
STACK ENDS


DGROUP GROUP _CODE, _DATA, STACK

	   ASSUME CS:DGROUP,DS:DGROUP,SS:DGROUP,ES:DGROUP

_DATA		SEGMENT PUBLIC

IM1  DW 2 DUP (0)

_DATA		ENDS

_CODE		SEGMENT PUBLIC

;
;INITIALIZE A INTERRUPT
; PROCEDURE 
;
	PUBLIC	INITIALIZE_INTERRUPT
;-----------------------------------------------------------------------;
; This procedure sets or restores a interrupt.				;
;									;K
;									;
;	AL	This is the vector number				;
;	ES:BX	Has CS:IP of new interrupt vector			;
;									;
; Returns: ES:BX Has 'old' interrupt vector CS:IP			;					     ;
;-----------------------------------------------------------------------;
INITIALIZE_INTERRUPT PROC  FAR

	PUSH	DX
	PUSH	DS
	PUSH	BX			;Save new IP of vector on stack.
	PUSH	ES			;Save new CS of vector on stack.
	MOV	AH,35h			;DOS function to ....
	INT	21h			;get Interupt vector CS:IP.
	POP	DS			;Get new CS of vector in DS form stack.
	POP	DX			;Get new IP of vector in DX form stack.
	MOV	AH,25h			;DOS function to ....						    ;DOS function to ....
	INT	21h			;set Interupt vector CS:IP.
	POP	DS
	POP	DX
	RETF

INITIALIZE_INTERRUPT ENDP

;
; CONVERT TO BINARY 
; PROCEDURE 
;
	PUBLIC	CONVERT_TO_BINARY
;-----------------------------------------------------------------------;
; This procedure converts a ASCII string to a binary number in AX.	;
;									;
; Uses: 								;
;									;
;	SI = address of ASCII string containing any of the characters	;
;	     +-.0123456789						;
; Returns:								;
;	AX = signed binary result					;
;	CX = number of digits after the decimal, or -1 if none		;
;	SI = address of first non-convertible character 		;
;-----------------------------------------------------------------------;
CONVERT_TO_BINARY  PROC  FAR

	CLD
	PUSH DX
	PUSH BX
	XOR BX,BX
	MOV CX,-1
CB1:	CMP BYTE PTR [SI],' '
	JNZ CB2
	INC SI
	JMP CB1
CB2:	PUSH SI
	CMP BYTE PTR [SI],'+'
	JZ CB25
	CMP BYTE PTR [SI],'-'
	JNZ CB3
CB25:	INC SI
CB3:	LODSB
	CMP AL,'.'
	JNZ CB4
	XOR CX,CX
	JMP CB3
CB4:	CMP AL,'0'
	JB CB5
	CMP AL,'9'
	JA CB5
	AND AX,0FH
	XCHG AX,BX
	MOV DX,10
	MUL DX
	ADD BX,AX
	OR CX,CX
	JS CB3
	INC CX
	JMP CB3
CB5:	DEC SI
	MOV AX,BX
	POP BX
	CMP BYTE PTR [BX],'-'
	JNZ CB6
	NEG AX
CB6:	POP BX
	POP DX
	RETF

CONVERT_TO_BINARY ENDP

;
; ASCII HEX TO HEX 
; PROCEDURE 
;
	PUBLIC	ASCII_HEX_TO_HEX
;-----------------------------------------------------------------------;
; This procedure converts a ASCII string to a binary number in AX.	;
;									;
; Example: If hex is '3F', AH = '3' AL = 'F'  result: AL = 3Fh		;
;									;
; Uses: 								;
;	AL = Ascii LSB AH = Ascii MSB					;			      ;
;									;
; Returns:								;
;	AL = hex byte							;
;-----------------------------------------------------------------------;
ASCII_HEX_TO_HEX  PROC	FAR

		TEST	AH,40H			;If "A" - "F"
		JZ	AH_EXIT
		SUB	AH,"A"-10		;Make 10-15
AH_EXIT:
		TEST	AL,40H			;If "A" - "F"
		JZ	AL_EXIT
		SUB	AL,"A"-10		;Make 10-15
AL_EXIT:
		AND	AX,0F0FH		;If "0" - "9", make 0-9
		SHL	AL,1
		SHL	AL,1
		SHL	AL,1
		SHL	AL,1
		OR	AL,AH			;Combine msn and lsn
		RETF				;That's all

ASCII_HEX_TO_HEX ENDP

;
; HEX TO ASCII HEX 
; PROCEDURE 
;
	PUBLIC	HEX_TO_ASCII_HEX
;-----------------------------------------------------------------------;
; This procedure converts a binary number in AL a ASCII string AX	;
;									;
; Example: If hex is '3F', AL = '3' AH = 'F'				;
;									;
; Uses: 								;
;	AL = = char to be translated					;
;									;
; Returns:								;
;	AL = msb of translation, AH = lsb of translation		;
;-----------------------------------------------------------------------;
HEX_TO_ASCII_HEX PROC FAR
		DB	0D4H,10H		;div AL/16-remainder in al
		OR	AX,3030H		;make ascii
		CMP	AL,"9"
		JBE	ALEXIT
		ADD	AL,7			;if a - f make "A" - "F"
ALEXIT:
		CMP	AH,"9"
		JBE	AHEXIT
		ADD	AH,7			;if a - f make "A" - "F"
AHEXIT:
		XCHG	AL,AH
		RETF				;that's all

HEX_TO_ASCII_HEX ENDP


;
; BINARY TO ASCII 
; PROCEDURE 
;
	PUBLIC	BINARY_TO_ASCII
;-----------------------------------------------------------------------;
; This procedure converts a 32-bit signed integer to ASCII.		;
;									;
; Uses: 								;
;	SI = offset to integer	DI = last byte of ASCII location	;			      ;
;									;
; Returns:								;
;	BX = offset to first character (sign) of ASCII value		;
;-----------------------------------------------------------------------;
BINARY_TO_ASCII   PROC	FAR

         PUSH     SI
         PUSH     DI
         SUB      DX,DX           ;clear DX & BX
         MOV      BX,DX
         MOV      AX,[SI]         ;get integer
         OR       DX,[SI]+2
				  ;check sign
         MOV      SI," "          ;assume positive sign
         JNS      ASC32A          ;if number negative
         NOT      AX              ;make it positive
         NOT      DX
         ADD      AX,1
         ADC      DX,0
         MOV      SI,"-"          ;and set negative sign

ASC32A:  PUSH     SI              ;save sign
				  ;break into two 3-4 digit integers
         MOV      BX,10000        ;decimal 10,000 in BX
         DIV      BX              ;divide integer by 10,000

         PUSH     AX              ;quotient--first 3 ASCII digits
         MOV      SI,OFFSET IM1   ;SI points to positive integer 
         MOV      IM1,DX          ;remainder in range 0-9,999
	 CALL	  FAR PTR ASC16   ;convert remainder to ASCII
				  ;check for zero quotient
         POP      AX              ;get the quotient
         OR       AX,AX
         JZ       ASC32D          ;finished if it is zero
				  ;adjust ASCII remainder
         MOV      CX,BX           ;pointer to ASCII sign in CX
         SUB      CX,DI           ;CX is count of ASCII digits
         ADD      CX,4            ;should be 4
         JZ       ASC32C          ;if it isn't
ASC32B:  MOV BYTE PTR [BX],"0"    ;fill it out with zeros
         DEC      BX
         LOOP     ASC32B
				  ;convert quotient
ASC32C:  MOV      DI,BX           ;DI points to next position
         MOV      SI,OFFSET IM1   ;SI points to location of
         MOV      IM1,AX          ;quotient in memory
	 CALL	  FAR PTR ASC16   ;convert it
				  ;set ASCII sign
ASC32D:  POP      SI              ;get sign
         MOV      AX,SI           ;put it in AL
	 MOV	  [BX],AL	  ;and save it
	 POP	  DI
	 POP	  SI

	 RETF

BINARY_TO_ASCII   ENDP


;
;16 BIT BINARY TO ASCII 
; PROCEDURE 
;

	PUBLIC	ASC16
;-----------------------------------------------------------------------;
; This procedure converts a 16-bit signed integer to ASCII.		;
;									;
; Uses: 								;
;	SI = offset to integer	DI = last byte of ASCII location	;			      ;
;									;
; Returns:								;
;	BX = offset to first character (sign) of ASCII value		;
;-----------------------------------------------------------------------;
ASC16	 PROC	  FAR

	 PUSH	  SI
         SUB      AX,AX           ;clear AX
         OR       AX,[SI]         ;get binary integer
				  ;check sign
         MOV      SI," "          ;assume sign positive
         JNS      ASC16A
         MOV      SI,"-"          ;save negative sign
         NEG      AX              ;and make integer positive
				  ;convert to ASCII decimal
ASC16A:  MOV      BX,DI           ;initial offset in BX
         MOV      CX,10           ;decimal 10 in CX
ASC16B:  SUB      DX,DX           ;clear DX
         DIV      CX              ;divide by 10
         ADD      DX,48           ;convert remainder to ASCII
         MOV      [BX],DL         ;save it
         DEC      BX              ;point to next position
         OR       AX,AX           ;if quotient is not zero
         JNZ      ASC16B          ;do it again
				  ;set sign
         MOV      AX,SI           ;sign in AL
         MOV      [BX],AL         ;save it

	 POP	  SI
	 RETF

ASC16	 ENDP


;
;32 BIT CONVERT ANY BASE ASCII 
; PROCEDURE 
;

	PUBLIC	CONVERT_ALL
;-----------------------------------------------------------------------;
; This procedure converts any 32 bit unsigned integer in any base	;
; to ASCII.								;
;									;
; Uses: 								;
;									;
;	AX = LSW of number to convert					;			      ;
;	DX = MSW of number to convert					;			      ;
;	BX = end of buffer address offset				;			      ;
;	SI = base quantity (2 to 36)					;
;	DI = start of buffer address offset				;			      ;
;	ES = buffer segment						;
;									;
; Returns:								;
;									;
;	ASCII string with LSB at starting at BX 			;
;									;
;-----------------------------------------------------------------------;

CONVERT_ALL    PROC FAR

	 push	 bp		  ;don't use macro here; bp-8 offset
	 mov	 bp,sp		  ;...must not be modified!
	 push	 si		  ;save base to convert for "move"
	 push	 bx		  ;save buffer end for "move"
	 push	 di		  ;save buffer start for "reverse"
	 xor	 bx,bx		  ;clear work register
	 push	 bx		  ;clear the dividend work reg
	 cld			  ;set for ascending STOSB action
	 xchg	 ax,bx
	 stosb			  ;put in terminating NULL first
	 xchg	 ax,bx
;
;	this does 32-bit division/remainder arithmetic
;
cv0:
	 mov	 cx,32		  ;32 bits must be shifted
cv1:
	 xchg	 cx,[bp-8]	  ;swap loop count/work reg
	 shl	 ax,1		  ;puts 0 bit in quotient
	 rcl	 dx,1
	 rcl	 bx,1
	 rcl	 cx,1
	 or	 cx,cx		  ;will it go?
	 jnz	 cv2		  ;yes since base is < 8 bits
	 cmp	 si,bx		  ;maybe...
	 ja	 cv3		  ;no
cv2:
	 sub	 bx,si		  ;32-bit subtract
	 sbb	 cx,0
	 inc	 ax		  ;sets low bit of Q to 1
cv3:
	 xchg	 cx,[bp-8]	  ;swap back
	 loop	 cv1		  ;do it for all 32 bits
;
;	quotient in DX:AX, remainder ( < base ) in BL, BH==0
;
	 xchg	 ax,bx		  ;set up to save remainder
	 add	 al,'0' 	  ;convert to ASCII
	 cmp	 al,'9'
	 jbe	 cv4		  ;not in A-F range
	 add	 al,7		  ;map to UC alpha
cv4:
	 stosb			  ;put it in buffer
	 mov	 al,ah		  ;clear work reg for next time
	 xchg	 ax,bx		  ;get LSW of quotient back
	 or	 ax,ax		  ;and test for conversion done
	 jnz	 cv0		  ;no, go do another divide
	 or	 dx,dx		  ;maybe...
	 jnz	 cv0		  ;no
;
;	this point is not reached until conversion is complete
;
cv5:
	 pop	 ax		  ;balance the stack (work reg word)
	 pop	 si		  ;offset to front of buffer
	 push	 si		  ;save buffer start for "move"
	 dec	 di		  ;point di to last character in buffer
	 push	 di		  ;save it until later
	 inc	 di		  ;return to orginal position
cv6:
	 dec	 di
	 cmp	 si,di		  ;check for overlap (or same)
	 jae	 cv7		  ;yep, all swapped around
	 mov	 ah,es:[si]	  ; note that lodsb/stosb would
	 mov	 al,es:[di]	  ; take more code because one
	 mov	 es:[di],ah	  ; is incrementing while the
	 mov	 es:[si],al	  ; other is decrementing
	 inc	 si
	 jmp	 cv6
cv7:
	 pop di 		  ;offset to last character
	 pop si 		  ;offset to front of buffer
	 pop bx 		  ;offset to end of buffer
	 pop dx 		  ;base to convert
	 xor cx,cx		  ;clear register
	 dec di 		  ;adjust di
	 mov ah,20h		  ;space in al
cv8:
	 cmp di,si		  ;if DI = SI we don't need to adjust the data placement.
	 jl cv11
	 cmp cx,3		  ;if cx 3 add a , to the buufer
	 jl cv9
	 xor cx,cx		  ;clear register
	 mov byte ptr[bx],","	  ;add , to buffer
	 dec bx
cv9:
	 mov al,byte ptr[di]	  ;get byte to move
	 mov byte ptr[bx],al	  ;move the byte
	 cmp dx,10		  ;if base 10 conversion
	 jne cv10		   ; increment cx for , count
	 inc cx
cv10:
	 dec bx
	 dec di
	 jmp cv8
cv11:
	 cmp si,bx
	 jg cv12
	 mov byte ptr[si],ah	  ;put space in buffer
	 inc si
	 jmp cv11
cv12:
	 mov	 sp,bp
	 pop	 bp
	 retf

CONVERT_ALL    ENDP

;--------------------------------------------------------------------

_CODE		ENDS

		END
